package
{
	import com.greensock.TweenMax;
	import com.greensock.easing.Linear;
	
	import flash.geom.Point;
	
	import flashx.textLayout.formats.Float;
	
	import mx.utils.StringUtil;
	
	import org.flixel.FlxG;
	import org.flixel.FlxObject;
	import org.flixel.FlxPath;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;
	
	
	public class Game
	{
		public static var piecetypes:Array = [ 
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[1,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,0,1,1],
					[0,1,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,1,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,1,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
				[
					[0,0,1,1],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,1,0,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
		];
				
		public var turn:int=0;
		
		public function get piecetype():int {
			return PickPiece(turn);
		}
		
		public var grid:Vector.<Vector.<int>>;
		
		public static var tilesize:int=8;
		public static var gridwidth:int=10;
		public static var gridheight:int=20;
		public static var exgridwidth:int=gridwidth+6;
		public static var exgridheight:int=gridheight+6;
		
		public static var xoffset:int = 16;
		public static var yoffset:int = -16;
		
		
		public var score:int=1000;
		public var scoremultiplier=1;
		
		function Game(desc:String="")
		{
			grid = new Vector.<Vector.<int>>();
			
			if (desc=="")
				return;
			
			var ar:Array = desc.split("\n");
			for (var i:int=0;i<ar.length;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				var s:String = ar[i];				
				//s = mx.utils.StringUtil.trim(s);
				for (var j:int=0;j<s.length;j++)
				{
					var c:String = s.charAt(j);
					if (c==" ")
						c="-1";
					var num:int = int(c);
					row.push(num);
				}
				grid.push(row);
			}
		}
		
		public static function Generate(width:int,height:int,maxnum:int,explosions:int):Game
		{
			var g:Game = new Game();
			
			var i:int=0;
			var j:int=0;
			g.score=1000;
			g.grid = new Vector.<Vector.<int>>();
			for (i=0;i<gridheight;i++)
			{
				var r:Vector.<int> = new Vector.<int>();
				for (j=0;j<gridwidth;j++)
				{
					r.push(i>10?1:0);//int(Math.random()*2):0);
				}
				r[int(Math.random()*r.length)]=0;
				r[int(Math.random()*r.length)]=0;
				g.grid.push(r);
			}			
			
			return g;
		}
		
		public function GetBlock(x:int,y:int):int
		{
			if (x<0 || y<0)
				return -1;
			if (y>=gridheight || x>=gridwidth)
				return -1;
			return grid[y][x];
		}
		
		
		public function CheckWin():Boolean
		{			
			//if a single tile left
			var nonzerocount:int=0;
			for (var i:int=0;i<grid.length;i++)
			{
				for (var j:int=0;j<grid[i].length;j++)
				{
					if (grid[i][j]>0)
						return false;
				}
			}
			
			return true;
		}
		
		public function GenSprites() : Vector.<FlxSprite>
		{
			var result:Vector.<FlxSprite> = new Vector.<FlxSprite>();
			for (var i:int=0;i<grid.length;i++)
			{
				for (var j:int=0;j<grid[0].length;j++)
				{
					if (grid[i][j]>0)
					{
						var s:FlxSprite = new FlxSprite(xoffset+j*tilesize,yoffset+i*tilesize,grid[i][j]==1?GameState.ImgBlock:GameState.ImgRedBlock);
						result.push(s);
					}							
				}
			}
			
			return result;
		}
		
		public var movedur:Number = 0.2;
		
		private function TryTween(s:FlxSprite,x:int,y:int):void
		{	
			/*
			if (lastx==-1||lasty==-1)
				return;
			
			if (x==lastx && y==lasty)
			{
				//s.visible=false;											
			}
			else if (x==lastx)
			{
				if (y<lasty)
					TweenMax.from(s,movedur,{x:s.x,y:s.y-tilesize});
				else
					TweenMax.from(s,movedur,{x:s.x,y:s.y+tilesize});					
			}
			else if (y==lasty)
			{
				if (x<lastx)
					TweenMax.from(s,movedur,{y:s.y,x:s.x-tilesize});
				else
					TweenMax.from(s,movedur,{y:s.y,x:s.x+tilesize});	
				
			}
			*/			
		}
		
		public function ClearMoved():void
		{
			//lastx=-1;
			//lasty=-1;			
		}
		
		//insert new row on row my, pushing everything on or above my up
		public function CanInsertRow(my:int):Boolean
		{
			//check top row empty
			for (var i:int=0;i<grid[0].length;i++)
			{
				if (grid[0][i]!=0)
					return false;
				if (grid[1][i]!=0)
					return false;
				if (grid[2][i]!=0)
					return false;
			}
			
			if (my==gridheight-1)
				return true;
			
			//needs to be piece on row below
			
			for (i=0;i<grid[0].length;i++)
			{
				if (grid[my+1][i]!=0)
					return true;
			}
			
			return false;
		}
		
		public function TryInsertRow(my:int):Boolean
		{
			if (CanInsertRow(my)==false)
				return false;
		
			for (var i:int=0;i<my;i++)
			{
				for (var j:int=0;j<gridwidth;j++)
				{
					grid[i][j]=grid[i+1][j];
				}
			}
			
			for (j=0;j<gridwidth;j++)
			{
				grid[my][j]=2;
			}
			
			score-=20*scoremultiplier;
			
			return true;
		}
		
		public function CanRemovePiece(mx:int,my:int,rotation:int):Boolean
		{
			var redrowsaccountedfor:Array =[];
			
			var k:int;
			var supported:Boolean=false;
			//all pieces must be on 
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					var blockcol:int = Game.piecetypes[piecetype][rotation][j][i];
					if (blockcol==1)
					{
						var worldcol:int = GetBlock(mx+i,my+j); 
						switch (worldcol)
						{
							case -1:
								return false;
								break;
							case 0:
								return false;
								break;
							case 1:
								var found:Boolean=false;
								//needs to be empty tile on the row somwhere
								for (k=0;k<gridwidth;k++)
								{
									if (grid[my+j][k]==0)
									{
										found=true;
										break;
									}
								}
								if (found==false)
									return false;	
								
								
							
								break;
							case 2:
								//make a note
								if (redrowsaccountedfor.indexOf(my+j)==-1)
								{
									redrowsaccountedfor.push(my+j);
								}
								
								
								break;
						}
						
						//needs to be  either a point below on the grid (or -1)
						
						// OR a point below in the block-shape								
						{
							//on bottom row - no hope left
							if (j==3)
							{
								if (GetBlock(mx+i,my+j+1)!=0)
								{
									supported=true;
								}
							}
							else
							{
								var lowercol:int = Game.piecetypes[piecetype][rotation][j+1][i];
								if (lowercol==0)
								{
									if (GetBlock(mx+i,my+j+1)!=0)
									{
										supported=true;
									}
								}
							}
						}
					}					
				}
			}
			
			if (supported==false)
				return false;
			//for each red row, check has been accounted for
			
			for (i=0;i<gridheight;i++)
			{
				if (grid[i][0]==2)
					if (redrowsaccountedfor.indexOf(i)==-1)
						return false;
			}			
						
			return CanPathFindTo(mx,my,rotation);
		}
		
		public var pathfinddata:Vector.<Point>;
		
		public var pathfindingdata:Vector.<Vector.<Vector.<int>>>;
		
		public var edges:Vector.<Array>;
		
		public function ClearPathfindingData():void
		{
			edges = new Vector.<Array>();
			pathfindingdata = new Vector.<Vector.<Vector.<int>>>();
			pathfindingsuccess=false;
			for (var i:int=0;i<gridwidth+4;i++)
			{
				var row:Vector.<Vector.<int>> = new Vector.<Vector.<int>>();;
				for (var j:int=0;j<gridheight+4;j++)
				{
					var entry:Vector.<int> = new Vector.<int>();
					for (var k:int=0;k<4;k++)
					{
						entry.push(0);
					}
					row.push(entry);
				}
				pathfindingdata.push(row);
			}			
			nodestohandle=new Vector.<int>;
		}
		
		public var nodestohandle:Vector.<int>;
		
		public function AddPathFindingPoint(mx:int,my:int,rotation:int):void
		{
			if(pathfindingdata[mx+2][my+1][rotation]!=0)
				return;
			
			var curcode:int = exgridheight*4*(mx+2)+4*(my+1)+rotation;
			
			pathfindingdata[mx+2][my+1][rotation]=1;
			var neighbours:Vector.<Array> = new Vector.<Array>();
			//add translations
			neighbours.push([mx-1,my,rotation]);
			neighbours.push([mx+1,my,rotation]);
			neighbours.push([mx,my-1,rotation]);
			//add rotations
			var rotcount:int=piecetypes[piecetype].length;
			if (rotcount>2)
			{
				neighbours.push([mx,my,(rotation+1)%rotcount]);
				neighbours.push([mx,my,(rotation+rotcount-1)%rotcount]);				
			}
			else if (rotcount>1)
			{				
				neighbours.push([mx,my,(rotation+1)%rotcount]);
			}
			for (var i:int=neighbours.length-1;i>=0;i--)
			{
				var ar:Array=neighbours[i];
				if (ar[1]<0)
				{
					pathfindingsuccess=true;
					found = exgridheight*4*(ar[0]+2)+4*(ar[1]+1)+ar[2];
					edges.push([curcode,found]);
					successcode=found;
					return;
				}
				
				if (ar[0]+2<0 || ar[1]+1<0 || ar[0]-1>=exgridwidth || ar[1]+1>=exgridheight)
				{
					return;
				}
				if (pathfindingdata[ar[0]+2][ar[1]+1][ar[2]]==0)
				{					
					if (this.SpaceForPieceInGridWhenPathFinding(ar[0],ar[1],ar[2]))
					{
						var found:int = exgridheight*4*(ar[0]+2)+4*(ar[1]+1)+ar[2];
						
						edges.push([curcode,found]);
						this.nodestohandle.push(found);
					}
					else
					{
						//failure, mark it as dead
						pathfindingdata[ar[0]+2][ar[1]+1][ar[2]]=-1;						
					}
				}
			}
		}
		
		private function sortnodestohandle():void
		{
			nodestohandle=nodestohandle.sort(nodecompare);
		}
		
		private function nodecompare(a:int,b:int):int
		{
			
			//var a_rotation:int=a%4;
			var a_my:int = ((int(a/4))%exgridheight)-1;
			//var a_mx:int = int(a/(4*18));
			
			//var b_rotation:int=b%4;
			var b_my:int = ((int(b/4))%exgridheight)-1;
			//var b_mx:int = int(b/(4*18));
			/*
			var dx_a:int=a_mx-t_mx;
			var dy_a:int=a_my-t_my;
			var dx_b:int=b_mx-t_mx;
			var dy_b:int=b_my-t_my;
			
			var mx:int =dx_a*dx_a+dy_a*dy_a;
			var my:int =dx_b*dx_b+dy_b*dy_b; 
			return ( mx < my) ? -1 : 1;
			*/
			return a_my<b_my ? -1 : 1;
		}
		
		public var pathfindingsuccess:Boolean=false;
		
		public var successcode:int;
		
		public var solutionpath:Vector.<Point>;
		public var rotvals:Vector.<int>;
		public function ProcessNodesToHandle():void
		{
			while (nodestohandle.length>0)
			{
				var enc:int = nodestohandle[0];
				var rotation:int=enc%4;
				var my:int = ((int(enc/4))%exgridheight) - 1;
				var mx:int = (int(enc/(4*exgridheight))%exgridwidth) - 2;
				AddPathFindingPoint(mx,my,rotation);
				nodestohandle.splice(0,1);
				//see if there's space for all of these
				sortnodestohandle();
				if (pathfindingsuccess)
					break;
			}
			
			if (pathfindingsuccess)
				buildsolutionpath();
		}
		private function buildsolutionpath():void
		{
			solutionpath = new Vector.<Point>();
			rotvals = new Vector.<int>();
			
			var end:int = successcode;
			solutionpath.push(codetocoord(end));
			rotvals.push(codetorot(end));
			var lastpoint:int = successcode;
			while (lastpoint!=pathfindingsourceenc)
			{
				for (var i:int=0;i<edges.length;i++)
				{
					var e:Array = edges[i];
					if (e[1]==lastpoint)
					{
						lastpoint=e[0];
						solutionpath.push(codetocoord(lastpoint));
						rotvals.push(codetorot(lastpoint));
						break;
					}
				}
			}
		}
		
		private function codetocoord(enc:int):Point
		{
			//var rotation:int=enc%4;
			var my:int = ((int(enc/4))%exgridheight) - 1;
			var mx:int = (int(enc/(4*exgridheight))%exgridwidth) - 2;
			
			return new Point(xoffset+(mx+2+0.5)*tilesize,yoffset+(my+1+0.5)*tilesize);			
		}
		
		private function codetorot(enc:int):int
		{
			return enc%4;
		}
		
		public var pathfindingsourceenc:int;
		
		public function CanPathFindTo(mx:int,my:int,rotation:int):Boolean
		{
			pathfinddata = new Vector.<Point>();
			
			var copy:Game = Copy();
			copy.TryRemove_Pathfinding(mx,my,rotation);
			copy.ClearPathfindingData();
			copy.pathfindingsourceenc = exgridheight*4*(mx+2)+4*(my+1)+rotation;
			copy.AddPathFindingPoint(mx,my,rotation);
			copy.ProcessNodesToHandle();
			pathfindingsuccess = copy.pathfindingsuccess;
			solutionpath=copy.solutionpath;
			rotvals = copy.rotvals;
			return copy.pathfindingsuccess;
		}
		
		
		public function PieceFitsInGrid(mx:int,my:int,rotation:int):Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					var blockcol:int = Game.piecetypes[piecetype][rotation][j][i];
					if (blockcol==1)
					{
						if (GetBlock(mx+i,my+j)==-1)
							return false;
					}
				}
			}
			return true;
		}
		
		
		
		public function SpaceForPieceInGridWhenPathFinding(mx:int,my:int,rotation:int):Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					var blockcol:int = Game.piecetypes[piecetype][rotation][j][i];
					if (blockcol==1)
					{
						if (GetBlock(mx+i,my+j)!=0)
							return false;
					}
				}
			}
			return true;
		}
		
		private function clearcolors():void
		{
			for(var i:int=0;i<gridwidth;i++)
			{
				for (var j:int=0;j<gridheight;j++)
				{
					if (grid[j][i]==2)
						grid[j][i]=1;
				}
			}
		}
		
		public function TryRemove_Pathfinding(mx:int,my:int,rotation:int):void
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					var blockcol:int = piecetypes[piecetype][rotation][j][i];
					if (blockcol==1)
					{
						grid[my+j][mx+i]=0;
					}
				}
			}
		}
		
		public function TryRemove(mx:int,my:int,rotation:int):Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					var blockcol:int = piecetypes[piecetype][rotation][j][i];
					if (blockcol==1)
					{
						grid[my+j][mx+i]=0;
					}
				}
			}
			turn++;
			scoremultiplier=1;
			PickPiece(turn);
			clearcolors();
			return true;
		}
		
		public var pieces:Vector.<int>=new Vector.<int>();
		public function PickPiece(turn:int):int
		{
			if (turn<0)
			{
				return 4;
			}
			
			if (pieces.length==0)
			{
				pieces.push(4);
				pieces.push(0);
				pieces.push(1);
				pieces.push(6);
				pieces.push(5);
			}
			while(pieces.length<=turn)
			{
				pieces.push(int(Math.random()*piecetypes.length));
			}
			return pieces[turn];
		}
		
		public function Copy():Game
		{
			var g:Game = new Game();
			for (var i:int=0;i<grid.length;i++)
			{
				var r:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<grid[i].length;j++)
				{
					r.push(grid[i][j]);
				}
				g.grid.push(r);
			}
			g.score=score;
			g.pieces=pieces;
			g.turn=turn;
			return g;
		}
	}
}