package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shader;
	import flash.display.Shape;
	import flash.filters.ShaderFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import org.flixel.*;
	import org.flixel.system.FlxList;

	public class GameState extends FlxState
	{			
		
		public static var tilesize:int = 8;
		
		[Embed(source="data/block.png")]
		public static var ImgBlock:Class;
		[Embed(source="data/redblock.png")]
		public static var ImgRedBlock:Class;
		[Embed(source="data/bg.png")]
		public static var ImgBg:Class;
		
		[Embed(source="data/shack.png")]
		public static var ImgShack:Class;
		
		[Embed(source="data/cursor.png")]
		public static var ImgCursor:Class;
		[Embed(source="data/cursor.png")]
		public static var ImgCursor2:Class;
		[Embed(source="data/cursor.png")]
		public static var ImgCursor3:Class;
		[Embed(source="data/rowcursor.png")]
		public static var ImgRowCursor:Class;
		
		[Embed(source="data/musicback.mp3")]
		public static var SndMusic:Class;
		[Embed(source="data/unpiece.mp3")]
		public static var SndPiece:Class;
		[Embed(source="data/unline.mp3")]
		public static var SndLine:Class;
		
				
		private var blockbmd:BitmapData;
		
		private var mapsprites:FlxGroup;
		
		
		private var game:Game;
		public var score:FlxText;
		
		public var undos:Vector.<Game>;
		
		private var gamegrp:FlxGroup;
		
		public var mouseover:FlxSprite;
		public var piecelifting:FlxSprite;
		public var nextpiece:FlxSprite;
		public var rowcursor:FlxSprite;
		
		public var pieceindex:int=0;
		
		
		
		override public function create():void
		{	
			
			FlxG.bgColor=FlxG.WHITE;
			
			super.create();
			
			FlxG.playMusic(SndMusic);
			var b:Bitmap = new ImgBlock();
			blockbmd = b.bitmapData;
			var bg:FlxSprite = new FlxSprite(0,0,ImgBg);
			add(bg);
			
			gamegrp  = new FlxGroup();
			add(gamegrp);
			
			piecelifting = new FlxSprite(-100,-100,ImgCursor2);
			add(piecelifting);
			piecelifting.visible=false;

			nextpiece = new FlxSprite(115,55,ImgCursor3);
			add(nextpiece);
			nextpiece.visible=true;

			mouseover = new FlxSprite(-100,-100,ImgCursor);
			add(mouseover);
			mouseover.visible=false;			
			
			rowcursor = new FlxSprite(-100,-100,ImgRowCursor);
			add(rowcursor);
			rowcursor.visible=false;
			
			pathspr = new FlxSprite(0,0);
			add(pathspr);
			
			undos = new Vector.<Game>();
			
			game = Game.Generate(10,10,9,100);
			
			score = new FlxText(105,22,55,game.score.toString());
			score.alignment="center";
			score.color=0xff525252;
			add(score);
			updateVisuals();
			
			//rotaebtn = new FlxButton(123,122,"rotate",rotateclick);
			//add(rotaebtn);
		}
		
		public function updatescore():void
		{
			score.text=game.score.toString();
		}
		
		public function rotateclick():void
		{
			if (animating)
				return;
			rotation++;
			BuildCursor();
			oldmx=-100;
			oldmy=-100;
			oldmyr=-100;
		}
		
		public function rotateclick_rev():void
		{
			if (animating)
				return;
			rotation--;
			BuildCursor();
			oldmx=-100;
			oldmy=-100;
			oldmyr=-100;
		}
		
		public function updateVisuals():void
		{			
			oldmx=1000;
			oldmy=1000;
			if (mapsprites!=null)
			{
				gamegrp.remove(mapsprites,true);
			}
			
			mapsprites = new FlxGroup();
			gamegrp.add(mapsprites);
			for each (var s:FlxSprite in game.GenSprites())
			{
				mapsprites.add(s);
			}	
			updatescore();
			BuildCursor();
			BuildNextPiece();
		}
		
		private function BuildCursor():void
		{
			if (rotation>=Game.piecetypes[game.piecetype].length)
				rotation=0;
			if(rotation<0)
			{
				rotation+=Game.piecetypes[game.piecetype].length;
			}
			
			var piecedat:Array = Game.piecetypes[game.piecetype][rotation];
			
			var p:BitmapData = mouseover.pixels;
			p.fillRect(p.rect,0x00000000);
			for (var i:int=0;i<piecedat.length;i++)
			{
				for (var j:int=0;j<piecedat[0].length;j++)
				{
					if (piecedat[i][j]==1)
					{
						p.fillRect(new Rectangle(j*Game.tilesize,i*Game.tilesize,8,8),0x88ffffff);
					}
				}
			}
			
			mouseover.pixels=p;
		}
		
		private function BuildNextPiece():void
		{
			if (rotation>=Game.piecetypes[game.piecetype].length)
				rotation=0;
			if(rotation<0)
			{
				rotation+=Game.piecetypes[game.piecetype].length;
			}
			
			var piecedat:Array = Game.piecetypes[game.PickPiece(game.turn-1)][0];
			
			var p:BitmapData = nextpiece.pixels;
			p.fillRect(p.rect,0x00000000);
			for (var i:int=0;i<piecedat.length;i++)
			{
				for (var j:int=0;j<piecedat[0].length;j++)
				{
					if (piecedat[i][j]==1)
					{
						p.copyPixels(blockbmd,blockbmd.rect,new Point(j*Game.tilesize,i*Game.tilesize));
					}
				}
			}
			
			nextpiece.pixels=p;
		}
		
		private function BuildLifting(ptype:int,prot:int):void
		{
			var piecedat:Array = Game.piecetypes[ptype][prot];
			
			var p:BitmapData = piecelifting.pixels;
			p.fillRect(p.rect,0x00000000);
			for (var i:int=0;i<piecedat.length;i++)
			{
				for (var j:int=0;j<piecedat[0].length;j++)
				{
					if (piecedat[i][j]==1)
					{
						p.copyPixels(blockbmd,blockbmd.rect,new Point(j*Game.tilesize,i*Game.tilesize));
					}
				}
			}
			
			piecelifting.pixels=p;
		}
		
		private var rotation:int=0;
		
		private var won:Boolean=false;
		private var fading:Boolean=false;
		
		private function FadeComplete():void
		{			
			FlxG.level++;
			
			
			if (FlxG.level+1>=11)
			{				
				FlxG.switchState(new TitleState());
				return;
			}
			else
			{								
				var save:FlxSave = new FlxSave();			
				if (save.bind("StressGame"))
				{
					save.data.level=FlxG.level;
				}
			}
			
			
			FlxG.switchState(new GameState());
			return;
			
			CutSceneState.cutscene=FlxG.level;
			FlxG.switchState(new CutSceneState());
		}
		
		public var oldmx:int=-1;
		public var oldmy:int=-1;
		public var oldmyr:int=-1;
		
		override public function draw():void
		{
			super.draw();						
		}
		
		public var pathspr:FlxSprite;
		public var pathbmd:BitmapData;
		private function drawpath():void
		{
			if (game.pathfindingsuccess==false|| game.solutionpath==null || game.solutionpath.length==0)
			{
				pathspr.visible=false;
				return;
			}
			pathspr.visible=true;
			
			if (pathbmd==null)
			{
				pathbmd = new BitmapData(FlxG.width,FlxG.height,true,0);
			}
			var drawing:Shape = new Shape();
			pathbmd.fillRect(pathbmd.rect,0);
			drawing.graphics.lineStyle(1, 0x000000);
			
			drawing.graphics.moveTo(game.solutionpath[0].x, game.solutionpath[0].y);			
						
			for (var i:int=1;i<game.solutionpath.length;i++)
			{
				drawing.graphics.lineTo(game.solutionpath[i].x, game.solutionpath[i].y);		
			}
			pathbmd.draw(drawing,new Matrix());
			
			pathspr.pixels=pathbmd;
		}
		
		private var canclick:Boolean=false;
		override public function update():void
		{
			if (animating)
			{
				mouseover.visible=false;
				animtick();
				super.update();
				return;
			}
			
			var mx:int = Math.floor((FlxG.mouse.x-Game.xoffset)/Game.tilesize)-2;
			var my:int = Math.floor( (FlxG.mouse.y-Game.yoffset)/Game.tilesize)-1;
			var myr:int = Math.floor( (FlxG.mouse.y-4)/Game.tilesize)+1;			
			
			if (mx!=oldmx||my!=oldmy||myr!=oldmyr)
			{
				canclick=false;
				oldmx=mx;
				oldmy=my;
				pathspr.visible=false;
				
				if (game.PieceFitsInGrid(mx,my,rotation))
				{
					mouseover.x=Game.xoffset+(mx)*Game.tilesize;
					mouseover.y=Game.yoffset+(my)*Game.tilesize;
					mouseover.visible=true;	
					rowcursor.visible=false;	
					game.solutionpath=null;
					if (game.CanRemovePiece(mx,my,rotation))
					{
						drawpath();
						mouseover.color=0x00ffff;
						canclick=true;
					}
					else 
					{
						mouseover.color=0xff0000;
					}
				}
				else if (mx<-2 || mx>7)//if (game.CanInsertRow(mx,myr))
				{
					game.solutionpath=null;
					rowcursor.x=10;
					rowcursor.y = Game.yoffset+(myr+1)*Game.tilesize
					mouseover.visible=false;
					rowcursor.visible=true;
					if (game.CanInsertRow(myr+1))
					{
						rowcursor.color=0x00ffff;	
						canclick=true;
					}
					else
					{
						rowcursor.color=0xff0000;
					}
				}
				else
				{
					mouseover.visible=false;
					rowcursor.visible=false;
				}
			}
			/*
			else
			{				
				mouseover.visible=false;
				rowcursor.visible=false;
			}*/
			/*
			if (FlxG.keys.justPressed("O"))
			{
				FlxG.level--;
				FlxG.switchState(new GameState());
				super.update();
				return;
			}
			if (FlxG.keys.justPressed("P"))
			{
				FlxG.level++;
				
				var save:FlxSave = new FlxSave();			
				if (save.bind("MG"))
				{
					save.data.level=FlxG.level;					
				}
				
				FlxG.switchState(new GameState());
				super.update();
				return;
			}*/			
			
			var modified:Boolean=false;
			var last:Game;
			if (TweenMax.getAllTweens().length>0)
			{
				
			}	
			else if (fading)
			{
				
			}
			else if (won)
			{				
				fading=true;
				var s:FlxSound = FlxG.play(TitleState.SndLevelWin);
				s.survive=true;
				FlxG.fade(0xff000000,0.5,FadeComplete,true);
			}		
			else if (FlxG.keys.justPressed("R"))
			{
				FlxG.switchState(new GameState());
			}
			
			else if (FlxG.keys.justPressed("Z"))
			{
				if (undos.length>0)
				{
					game=undos.pop();
					updateVisuals();
				}
			}
			else if (FlxG.mouse.justPressed() &&canclick)
			{
				if (game.PieceFitsInGrid(mx,my,rotation))
				{
					game.ClearMoved();
					last=game.Copy();
					var piece:int=game.piecetype;
					modified = game.TryRemove(mx,my,rotation);
					animate(piece);
					FlxG.play(SndPiece);					
					won = game.CheckWin();					
				}
				else if (game.CanInsertRow(myr+1))
				{
				//nothing
					game.ClearMoved();
					last=game.Copy();
					modified = game.TryInsertRow(myr+1);
					FlxG.play(SndLine);
					won = game.CheckWin();
					
				}
			}
			if (FlxG.keys.justPressed("Q"))
			{
				rotateclick();				
			}
			
			if (FlxG.keys.justPressed("W"))
			{
				rotateclick_rev();				
			}
			/*
			else if (FlxG.keys.UP)
			{				
				game.ClearMoved();				
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.UP);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.DOWN)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.DOWN);
				won=game.ProcessMoves();	
			}
			else if (FlxG.keys.LEFT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.LEFT);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.RIGHT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.RIGHT);
				won=game.ProcessMoves();
			}*/
			
			if (modified)
			{
				undos.push(last);
				
				updateVisuals();						
			}
			/*
			if (game.progress>oldprogress)
			{
				FlxG.play(SndPingLow);
			}*/
			super.update();
		}	
		
		public var solutionpath:Vector.<Point>;
		public var rotvals:Vector.<int>;
		public var animpiece:int;
		private var animating:Boolean;
		private var animframe:int;
		private var animsubframe:Number;		
		private var framelength:Number=0.1;
		
		public var rotaebtn:FlxButton;
		
		private function animate(piece:int):void
		{			
			mouseover.visible=false;
			rowcursor.visible=false;
			pathspr.visible=false;
			animating=true;
			animframe=-1;
			animsubframe=framelength;
			animpiece=piece;
			solutionpath = game.solutionpath;
			rotvals = game.rotvals;
			
			solutionpath = solutionpath.reverse();
			rotvals = rotvals.reverse();
			if (solutionpath.length>0)
			{
				piecelifting.x=solutionpath[0].x-2*tilesize-tilesize/2;
				piecelifting.y=solutionpath[0].y-1*tilesize-tilesize/2;
			}
		}
		
		private function animtick():void
		{
			animsubframe+=FlxG.elapsed;
			if (animsubframe>framelength)
			{
				animsubframe=0;
				animframe++;
				if (animframe>=solutionpath.length)
				{					
					animating=false;
					piecelifting.visible=false;
					return;
				}
				piecelifting.visible=true;
				buildanimpiece();
				TweenLite.to(piecelifting,framelength,{"x":solutionpath[animframe].x-2*tilesize-tilesize/2,"y":solutionpath[animframe].y-1*tilesize-tilesize/2});
			}
			
		}
		
		private function buildanimpiece():void
		{
			BuildLifting(animpiece,rotvals[animframe]);
		}
	}
	
	
	
}